rem   Arguments must be folder names with full paths.  
rem   Drag and drop is supported. Multiple folders can be dragged onto this .bat file and they will be processed in sequence.

:cont

if '%1' == ''  goto end

for %%F in (%1) do set folder=%%~F
for %%F in ("%folder%") do set filebase=%%~nF

for %%F in ("%folder%\%filebase%_*.dng") do c:\utils\dcraw -v -w -T -W -g 4 0 "%%F"

c:\utils\ffmpeg -y -r 30000/1001 -i "%folder%\%filebase%_%%06d.tiff" -i "%folder%\%filebase%.wav" -vf scale=out_color_matrix=bt709,crop=w=1920:h=1080 -pix_fmt yuv420p -vcodec libx264 -x264opts qp=14:ipratio=1:pbratio=1:keyint=17:colormatrix=bt709:colorprim=bt709 -b:a 256k "%folder%\..\%filebase%_sRGBgamut_gamma4.mp4"

rem c:\utils\ffmpeg -y -r 30000/1001 -i "%folder%\%filebase%_%%06d.tiff" -i "%folder%\%filebase%.wav" -vf scale=out_color_matrix=bt709,crop=w=1920:h=1080 -vcodec v210 -acodec pcm_s16le "%folder%\..\%filebase%_sRGBgamut_gamma4_V210.avi"

copy /y "%folder%\%filebase%.wav" "%folder%\..\%filebase%.wav"
del "%folder%\%filebase%_*.tiff"


rem 1920 x 1080 center cropping for the BMPCC
rem Don't forget to set the input frame rate.  30000/1001 is 29.970 fps.
rem Must specify out_color_matrix=bt709 in the scale filter, or else the RGB to Y'CbCr conversion will use the bt601 matrix.
rem ffmpeg can't put PCM audio in an .MP4 file, so save the .wav audio also.
rem I would love to use 10-bit h.264, but Vegas can only read that in an MXF file, which ffmpeg doesn't support for 10-bit h.264.
rem Optionally generate a 10-bit YUV (V210 format) uncompressed AVI.  The files are huge.  In that case, use the -6 option for dcraw to
rem generate 16-bit TIFFs for greater precision. 
rem 16-bit TIFF files are twice as big and slow down processing by a lot. In theory 8-bit h.264 could also benefit from the higher precision
rem source files, but in practice it makes little difference and the processing is slow enough already with 8-bit TIFFs.
rem If you're doing this processing on an SSD, then I guess 16-bit TIFFs won't slow down processing by much.

shift
goto cont

:end
pause
